<?php
/*
 * Copyright (c) 2012, MEDIASTUTTGART, http://mediastuttgart.de
 *
 * This file is released under the terms of the MIT license.
 * You can find the complete text in the attached LICENSE
 * file or online at:
 *
 * http://www.opensource.org/licenses/mit-license.php
 */

/**
 * Hg_Interface_Command
 */
interface Hg_Interface_Command {
	/**
	 * Execute command
	 *
	 * @param <array> $params Array of parameters
	 *
	 * @return <Hg_Command> Instance of the command
	 */
	public function execute(array $params = array());

	/**
	 * Get status
	 *
	 * @return <int> Status return from executed command
	 */
	public function getStatus();

	/**
	 * Get command string
	 *
	 * @return <string> Command string which was executed
	 */
	public function getCommand();

	/**
	 * Get output
	 *
	 * @param <string> $type Type of the output
	 * @param <string> $format Format of the output
	 *
	 * @return <mixed> Formatted output by type and format
	 */
	public function getOutput($type = null, $format = null);
}
