<?php
/*
 * Copyright (c) 2012, MEDIASTUTTGART, http://mediastuttgart.de
 *
 * This file is released under the terms of the MIT license.
 * You can find the complete text in the attached LICENSE
 * file or online at:
 *
 * http://www.opensource.org/licenses/mit-license.php
 */

/**
 * Hg_Proxy
 */
class Hg_Proxy {
	/**
	 * Service
	 *
	 * @var <Hg_Service>
	 */
	protected $service;

	/**
	 * Command
	 *
	 * @var <string>
	 */
	protected $command;

	/**
	 * Constructor
	 *
	 * @param <Hg_Service> $service Instance of Hg_Service
	 */
	public function __construct(Hg_Service $service) {
		$this->service = $service;
	}

	/**
	 * Magic call
	 *
	 * @param <string> $method Method to call
	 * @param <array> $arguments Arguments to pass
	 *
	 * @throws <Hg_Exception> Throws Hg_Exception
	 *
	 * @return <mixed> Instance of initiated command
	 */
	public function __call($method, $arguments = null) {
		$class = 'Hg_Command_' . ucfirst($method);

		if (class_exists($class)) {
			$this->command = new $class($arguments, $this->service);

			return $this->command;
		}
		else {
			throw new Hg_Exception(sprintf('The class (%s) you are trying to access is not implemented yet.', $class));
		}
	}
}
