<?php
/*
 * Copyright (c) 2012, MEDIASTUTTGART, http://mediastuttgart.de
 *
 * This file is released under the terms of the MIT license.
 * You can find the complete text in the attached LICENSE
 * file or online at:
 *
 * http://www.opensource.org/licenses/mit-license.php
 */

/**
 * Mercurial_Model_Repository_Container
 */
class Mercurial_Model_Repository_Container extends Mercurial_Model_Repository implements Mercurial_Interface_Repository {
	/**
	 * Repository Title
	 *
	 * @var <string>
	 */
	public $title;

	/**
	 * Repository directory
	 *
	 * @var <string>
	 */
	public $directory;

	/**
	 * Repository Source
	 *
	 * @var <string>
	 */
	public $source;

	/**
	 * Repository options
	 *
	 * @var <array>
	 */
	public $options;

	/**
	 * Public getters
	 */
	public function getTitle()     { return $this->title; }
	public function getDirectory() { return $this->directory; }
	public function getSource()    { return $this->source; }
	public function getOptions()   { return $this->options; }

	/**
	 * Constructor
	 *
	 * @param <array> $data Array of repository container data
	 */
	public function __construct($data) {
		foreach ($data as $key => $value) {
			$this->$key = $value;
		}
	}

	/**
	 * Transform container into a real repository
	 *
	 * @return <Mercurial_Model_Repository> Instance of a repository
	 */
	public function transform() {
		$data = array(
			'title'     => $this->title,
			'directory' => $this->directory
		);

		$service = Mercurial_Service::getService('repository');

		return $service->create($data);
	}
}
