<?php
/*
 * Copyright (c) 2012, MEDIASTUTTGART, http://mediastuttgart.de
 *
 * This file is released under the terms of the MIT license.
 * You can find the complete text in the attached LICENSE
 * file or online at:
 *
 * http://www.opensource.org/licenses/mit-license.php
 */

/**
 * Mercurial service class
 */
abstract class Mercurial_Service {
	/**
	 * Get service
	 *
	 * @param <string> $service Service to instantiate
	 * @param <mixed> $repository Instance of Mercurial_Model_Repository or repository directory as string
	 *
	 * @return <Mercurial_Service> The instantiated service
	 *
	 * @throws <Hg_Exception> Hg_Exception
	 */
	public static function getService($service, $repository = null) {
		$service = 'Mercurial_Service_' . ucfirst($service);

		if (class_exists($service)) {
			return new $service($repository);
		}
		else {
			throw new Hg_Exception(sprintf('Cannot instantiate service. Class (%s) not implemented yet.', $service));
		}
	}
}
