<?php
/*
 * Copyright (c) 2012, MEDIASTUTTGART, http://mediastuttgart.de
 *
 * This file is released under the terms of the MIT license.
 * You can find the complete text in the attached LICENSE
 * file or online at:
 *
 * http://www.opensource.org/licenses/mit-license.php
 */

/**
 * Sly form mercurial tree class
 */
class sly_Form_Mercurial_Tree extends sly_Form_Input_Text {
	/**
	 * Constructor
	 *
	 * @param <string> $name Name of the element
	 * @param <string> $label Label of the element
	 * @param <string> $value Value of the element
	 * @param <int> $id ID of the element
	 */
	public function __construct($name, $label, $value = '', $id = null) {
		parent::__construct($name, $label, $value, $id);
		$this->setAttribute('type', 'hidden');
		$this->setAttribute('class', $name . '_hidden');
	}

	/**
	 * Render form element
	 *
	 * @return <string> Rendered form element
	 */
	public function render() {
		$layout = sly_Core::getLayout();
		$layout->addJavascript('$(document).ready(function() { Mercurial.initMercurialTree(\'' . $this->getName() . '\') });');

		return '<div class="' . $this->getName() . '"></div><input ' . $this->getAttributeString() . ' />' . ($this->annotation ? ' ' . $this->annotation : '');
	}
}